<div class="flex flex-col h-screen">
  <mat-card class="m-4">
    <mat-card-header class="m-2">
      <mat-card-title>
        <div class="flex">
          <button class="secondary-icon mr-3" (click)="back()"><mat-icon>keyboard_backspace</mat-icon></button>
        {{ name || 'New SAML' }}</div></mat-card-title>
    </mat-card-header>
    <mat-card-content class="flex flex-col">
      <form [formGroup]="samlForm">
        <mat-form-field class="w-full">
          <mat-label>SAML App Name</mat-label>
          <input matInput formControlName="name" required />
          <mat-checkbox formControlName="isDisabled" matSuffix
            class="client-checkboxes">Disable SAML App</mat-checkbox>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Description</mat-label>
          <input matInput formControlName="description" />
          <mat-checkbox formControlName="encryptThenSign" matSuffix
            class="client-checkboxes">Encrypt Then Sign</mat-checkbox>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>SP Metadata XML</mat-label>
          <textarea matInput formControlName="spMetadataXml"></textarea>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Cert</mat-label>
          <textarea matInput formControlName="cert"></textarea>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Key</mat-label>
          <textarea matInput formControlName="key"></textarea>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Private Key Password</mat-label>
          <input matInput  formControlName="privateKeyPass"
            [type]="hidePrivateKeyPass ? 'password' : 'text'">
          <mat-icon matSuffix (click)="hidePrivateKeyPass = !hidePrivateKeyPass">{{hidePrivateKeyPass ? 'visibility_off' :
            'visibility'}}</mat-icon>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Relay State</mat-label>
          <input matInput formControlName="relayState" />
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Scope</mat-label>
          <mat-select formControlName="scope">
            <mat-option *ngFor="let scope of scopeList" [value]="scope.name">
              {{ scope.name }}
            </mat-option>
          </mat-select>
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Name ID Attribute</mat-label>
          <input matInput formControlName="nameIDAttribute" />
        </mat-form-field>
        <mat-form-field class="w-full">
          <mat-label>Custom Login URL</mat-label>
          <input matInput formControlName="scope" />
        </mat-form-field>
        <div
          *ngFor="
            let scp of samlForm.get('claimTypes')['controls'];
            let i = index
          "
          formArrayName="claimTypes">
          <div [formGroupName]="i">
            <hr style="border-top: 1px solid #666; margin: 16px 0;" />
            <mat-form-field class="w-1/2 pr-3">
              <mat-label>Claim ID</mat-label>
              <input matInput formControlName="claimId" />
            </mat-form-field>
            <mat-form-field class="w-1/2">
              <mat-label>Claim Display Name</mat-label>
              <input matInput formControlName="claimDisplayName" />
            </mat-form-field>
            <mat-form-field class="w-1/2 pr-3">
              <mat-label>Name</mat-label>
              <input matInput formControlName="name" />
            </mat-form-field>
            <mat-form-field class="w-1/2">
              <mat-label>Value Tag</mat-label>
              <input matInput formControlName="valueTag" />
            </mat-form-field>
            <mat-form-field class="w-1/2 pr-3">
              <mat-label>Name Format</mat-label>
              <input matInput formControlName="nameFormat" />
            </mat-form-field>
            <mat-form-field class="w-1/2">
              <mat-label>Value Xsi Type</mat-label>
              <input matInput formControlName="valueXsiType" />
              <button
                mat-icon-button
                color="accent"
                matSuffix
                (click)="removeClaimTypes(i)">
                <mat-icon>close</mat-icon>
              </button>
            </mat-form-field>
          </div>
        </div>
        <button mat-button color="accent" (click)="addClaimTypes()">
          Add Claim Types<mat-icon>add</mat-icon>
        </button>
      </form>
    </mat-card-content>
    <mat-card-actions class="m-4 flex flex-row gap-2">
      <button (click)="createSAML()" mat-flat-button color="primary"
        [disabled]="!samlForm.valid"
        *ngIf="!uuid">Create</button>
      <button (click)="updateSAML()" mat-flat-button color="primary"
        [disabled]="!samlForm.valid"
        *ngIf="uuid">Update</button>
      <button (click)="delete()" mat-flat-button color="warn"
        *ngIf="uuid && uuid !== new">Delete</button>
    </mat-card-actions>
  </mat-card>
</div>
